#/usr/bin/bash
mode="dev"


if [ -n "$2" ]; then
	if [[ $1 =~ ^(prod)$ ]]; then 
  		mode=$1 
	fi
fi

if [ $mode == "dev" ]; then
    echo "[Installing AURA ENGINE for Development]"
fi
if [ $mode == "prod" ]; then
    echo "[Installing AURA ENGINE for Production]"
fi


# Production 

if [ $mode == "api" ]; then
    if getent passwd 'engineuser' > /dev/null 2>&1; then  
        echo "User 'engineuser' exists already."; 
    else     
        echo "Creating Engine User ..."
        adduser engineuser
        adduser engineuser sudo
    fi
    
    echo "Set Ownership of '/opt/aura/engine' to Engine User"
    chown -R engineuser:engineuser .

    echo "Copy Supervisor Config to '/etc/supervisor/conf.d'"
    cp configuration/supervisor/engine-api.conf /etc/supervisor/conf.d/

    echo "Create Log Directory `/var/log/aura/engine`"
    mkdir -p /var/log/aura
    mkdir -p /var/log/aura/engine

    echo "Create Configuration Directory `/etc/aura/engine`"
    mkdir -p /etc/aura
    mkdir -p /etc/aura/engine
fi


# Development and Production

echo "Create local Logs Folder ..."
mkdir -p logs

echo "Installing Web Application Packages ..."
./install-web.sh

echo "Installing Python Requirements ..."
python3.7 $(which pip3) install -r requirements.txt